﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Locomotive
{
    internal static class ExtentionLocomotive
    {
        private static readonly char _separatorForObject = ':';
        public static string getDataForSave(this DrawningLocomotive drawningLocomotive)
        {
            var locomotive = drawningLocomotive.Locomotive;
            var str = $"{locomotive.Speed}{_separatorForObject}{locomotive.Weight}{_separatorForObject}{locomotive.BodyColor.Name}";
            if (locomotive is not EntityWarmlyLocomotive warmlyLocomotive)
            {
                return str;
            }
            return $"{str}{_separatorForObject}{warmlyLocomotive.ExtraColor.Name}{_separatorForObject}{warmlyLocomotive.Pipe}{_separatorForObject}{warmlyLocomotive.FuelStorage}";
        }

        public static DrawningLocomotive createDrawningLocomotive(this string info)
        {
            string[] strs = info.Split(_separatorForObject);
            if (strs.Length == 3)
            {
                return new DrawningLocomotive(
                    Convert.ToInt32(strs[0]),
                    Convert.ToInt32(strs[1]), 
                    Color.FromName(strs[2])
                );
            }
            if (strs.Length == 6)
            {
                return new DrawningWarmlyLocomotive(
                    Convert.ToInt32(strs[0]),
                    Convert.ToInt32(strs[1]),
                    Color.FromName(strs[2]),
                    Color.FromName(strs[3]),
                    Convert.ToBoolean(strs[4]),
                    Convert.ToBoolean(strs[5])
                );
            }
            return null;
        }
    }
}
