﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Locomotive
{
    internal interface IDrawningObject
    {
        /// Шаг перемещения объекта
        public float Step { get; }
        /// Установка позиции объекта
        void SetObject(int x, int y, int width, int height);
        /// Изменение направления перемещения объекта
        void MoveObject(Direction direction);
        /// Отрисовка объекта
        void DrawningObject(Graphics g);
        /// Получение текущей позиции объекта
        (float Left, float Right, float Top, float Bottom) GetCurrentPosition();

        // Получение информации по объекту
        string getInfo();
    }
}
